// Cegep.cpp: implementation of the CCegep class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "search.h"
#include "Cegep.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCegep::CCegep()
{
	pLocal = NULL;
	/*
	for (UINT i=0; i<NBLOCAL; i++)
	{
		InsereLocal(i, CLocal() );
	}*/
}

CCegep::~CCegep()
{
	if (pLocal) delete pLocal;
}

bool CCegep::InsereLocal(CLocal *local)
{
	CLocal **suivant = &pLocal;
	while (*suivant)
			suivant = &(*suivant)->suivant;
	*suivant = local;
	return true;
}

bool CCegep::IPDansLocal(CString IP, CLocal *local)
{
	COrdi *ordiTrouve;
	ordiTrouve = local->OrdiDansLocal(IP);

	return (ordiTrouve != NULL);
}

CString CCegep::TrouveOrdi(CString IP)
{
	char r[13];
	CLocal *lSuivant = pLocal;
	COrdi *oSuivant;
	while (lSuivant)
	{
		oSuivant = lSuivant->ordi;
		while (oSuivant)
		{
			if (IP == oSuivant->ip)
			{
				sprintf(r, "WKS-%s-%3s", lSuivant->NoLocal, oSuivant->id);
				return CString(r);
			}
			oSuivant = oSuivant->suivant;
		}
		lSuivant = lSuivant->suivant;
	}
	return _T("");
}

COrdi* CCegep::SetOrdiUser(CString IP, User user)
{
	CLocal *lSuivant = pLocal;
	COrdi *oSuivant;
	while (lSuivant)
	{
		oSuivant = lSuivant->ordi;
		while (oSuivant)
		{
			if (IP == oSuivant->ip)
			{
				oSuivant->user = user;
				return oSuivant;
			}
			oSuivant = oSuivant->suivant;
		}
		lSuivant = lSuivant->suivant;
	}
	return NULL;
}

void CCegep::Lister(CComboBox *combobox)
{
	CLocal *lSuivant = pLocal;
	int i=0;
	while (lSuivant)
	{
		combobox->InsertString(i++, lSuivant->NoLocal);
		lSuivant = lSuivant->suivant;
	}
}

const char FILE_LOG[] = "log.log";
const char FILE_CEGEP_XML[] = "cegep.xml";

bool CCegep::LireXML()
{
	FILE *fxml, *fLog;
	char ligne[FILE_LMAX+1];
	
	if ( ! ( fxml = fopen(FILE_CEGEP_XML, "rt") ) )
	{
		 		
		if ( fLog = fopen(FILE_LOG, "at") ) 
		{
			fprintf(fLog, "Erreur d'ouverture de la liste des ordinateurs : %s", FILE_CEGEP_XML);
			fclose(fLog);
		}
		return false;

	}

	fgets(ligne, FILE_LMAX, fxml);
	while ( ! feof(fxml) )
	{
		if ( isXMLStart( ligne, "cegepClass" ) )
			LireCegepClass(fxml);
		if (! feof(fxml)) 
			fgets(ligne, FILE_LMAX, fxml);
	}
	fclose (fxml);
	return true;
}

void CCegep::LireCegepClass(FILE *fxml)
{
	char ligne[FILE_LMAX+1];

	fgets(ligne, FILE_LMAX, fxml);
	while (! feof(fxml) && !isXMLEnd( ligne, "cepepClass") )
	{
		if ( isXMLStart( ligne, "local" ) )
		{
			CLocal *local = new CLocal;
			local->InitLocalXML(fxml, ligne);
			InsereLocal(local);
		}
		fgets(ligne, FILE_LMAX, fxml);
	}
}


CLocal* CCegep::TrouveLocal(int i)
{
	int cpt=0;
	CLocal *lSuivant= pLocal;
	while (lSuivant)
	{
		if (cpt == i)
			return lSuivant;
		cpt++;
		lSuivant = lSuivant->suivant;
	}
	return NULL;

}
