// DlgPlan.cpp : implementation file
//

#include "stdafx.h"
#include "search.h"
#include "DlgPlan.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgPlan dialog


CDlgPlan::CDlgPlan(CCegep* cegep /*= NULL*/, CWnd* pParent /*=NULL*/)
	: CDialog(CDlgPlan::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgPlan)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	this->cegep = cegep;
	penlog.CreatePen(PS_SOLID, 2, RGB(255,0,0));
	penunlog.CreatePen(PS_SOLID, 1, RGB(192,192,192));
	penselect.CreatePen(PS_SOLID, 3, RGB(0,0,255));
	pennobody.CreatePen(PS_SOLID, 1, RGB(0,0,0));
	font.CreateFont(12, 0, 0, 0, FW_DONTCARE, FALSE, FALSE, FALSE, ANSI_CHARSET, 
		            OUT_STRING_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
					DEFAULT_PITCH, NULL);
	defaut=0;
}


void CDlgPlan::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgPlan)
	DDX_Control(pDX, IDC_CBOLOCAL, m_cbolocal);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgPlan, CDialog)
	//{{AFX_MSG_MAP(CDlgPlan)
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_WM_PAINT()
	ON_CBN_SELCHANGE(IDC_CBOLOCAL, OnSelchangeCbolocal)
	ON_BN_CLICKED(IDC_BTNFLUSH, OnBtnflush)
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgPlan message handlers

int CDlgPlan::DessinerPlan(int i, CPaintDC *pDC)
{
	CRect rect;
	CString str;
	CPen *oldpen;

	CLocal *pLocal = cegep->TrouveLocal(i); 
	if (!pLocal)
		return -1;

	COrdi *oSuivant = pLocal->ordi;
	while(oSuivant)
	{
		if (oSuivant->point!=CPoint(0,0))
		{
			rect.SetRect(oSuivant->point.x - 20, 
						 oSuivant->point.y - 20, 
						 oSuivant->point.x + 20,
						 oSuivant->point.y + 20);
			if (oSuivant->select)
				oldpen = pDC->SelectObject(&penselect);
			else
			{
				if (oSuivant->ip != "")
				{
					if ( !oSuivant->user.IsEmpty())
						oldpen = pDC->SelectObject(&penlog);
					else
						oldpen = pDC->SelectObject(&pennobody);
				}
				else
					oldpen = pDC->SelectObject(&penunlog);
			}

			pDC->Rectangle(rect);
			pDC->SetBkMode(OPAQUE);
			pDC->SetBkColor(RGB(255,255,255));
			pDC->SetTextColor(0);
			pDC->DrawText(oSuivant->id, rect, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
			pDC->SetBkMode(TRANSPARENT);
			pDC->TextOut(oSuivant->point.x-20, 
				         oSuivant->point.y+19, 
						 oSuivant->user.matricule);
			pDC->SelectObject(oldpen);
		}
		oSuivant = oSuivant->suivant;
	}
	if (!user.IsEmpty())
	{
		pDC->TextOut(525, 160, user.matricule);
		pDC->TextOut(525, 190, user.nom);
		pDC->TextOut(525, 220, user.prenom);
		pDC->TextOut(525, 250, user.contexte);
	}
	pDC->TextOut(195,305, "* Si votre ordi est non list, envoyer moi le numro (WKS-XXXX-XX) et le IP.");

	return 1;
}

void CDlgPlan::OnDestroy() 
{
	CDialog::OnDestroy();
	// TODO: Add your message handler code here
	
}

int CDlgPlan::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CRect rect;
	int i=defaut;
	bool selection = false;

	CLocal *pLocal = cegep->TrouveLocal(i); 
	if (!pLocal)
		return -1;

	COrdi *oSuivant = pLocal->ordi;
	while(oSuivant)
	{
		if (oSuivant->point!=CPoint(0,0))
		{
			rect.SetRect(oSuivant->point.x - 20, 
						 oSuivant->point.y - 20, 
						 oSuivant->point.x + 20,
						 oSuivant->point.y + 20);

			if (rect.PtInRect(point))
			{
				oSuivant->select = true;
				selection = true;
				user = oSuivant->user;
				if (oSuivant->ip == "")
					AfxMessageBox("ordi non list ;-(", 0, 0);
			}
			else
				oSuivant->select = false;
		}
		oSuivant = oSuivant->suivant;
	}
	if (!selection)	
		user.Flush();
	CDialog::OnLButtonDown(nFlags, point);
	RedrawWindow();
	return 1;
}

void CDlgPlan::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	dc.SelectObject(&font);
	DessinerPlan(defaut, &dc);
	// TODO: Add your message handler code here
	
	// Do not call CDialog::OnPaint() for painting messages
}

void CDlgPlan::OnSelchangeCbolocal() 
{
	// TODO: Add your control notification handler code here
	defaut = m_cbolocal.GetCurSel();
	RedrawWindow();
}

BOOL CDlgPlan::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CPaintDC dc(this);
	cegep->Lister(&m_cbolocal);
	m_cbolocal.SetCurSel(defaut);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgPlan::OnBtnflush() 
{
	// TODO: Add your control notification handler code here

	CLocal *pLocal = cegep->TrouveLocal(defaut); 
	if (pLocal)
		pLocal->Flush();
	RedrawWindow();
}

void CDlgPlan::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	OnLButtonDown(nFlags,point);
	if (!user.IsEmpty())	OnOK();
	
	CDialog::OnLButtonDblClk(nFlags, point);
}
