// DlgUserPref.cpp : implementation file
//

#include "stdafx.h"
#include "search.h"
#include "DlgUserPref.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgUserPref dialog


CDlgUserPref::CDlgUserPref(UserPref *userpref /*=NULL*/, CWnd* pParent /*=NULL*/)
	: CDialog(CDlgUserPref::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgUserPref)
	m_image = _T("");
	m_textcolor = 0;
	m_bkcolor = 0;
	m_Transparent = FALSE;
	//}}AFX_DATA_INIT

	this->userpref = userpref;
	Init();
}


void CDlgUserPref::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgUserPref)
	DDX_Text(pDX, IDC_IMAGE, m_image);
	DDX_Text(pDX, IDC_TEXTCOLOR, m_textcolor);
	DDX_Text(pDX, IDC_BKCOLOR, m_bkcolor);
	DDX_Check(pDX, IDC_TRANSPARENT, m_Transparent);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgUserPref, CDialog)
	//{{AFX_MSG_MAP(CDlgUserPref)
	ON_BN_CLICKED(IDC_CMDBKCOLOR, OnCmdbkcolor)
	ON_BN_CLICKED(IDC_CMDFONTCOLOR, OnCmdfontcolor)
	ON_BN_CLICKED(IDC_CMDIMAGE, OnCmdimage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgUserPref message handlers

void CDlgUserPref::OnCmdbkcolor() 
{
	// TODO: Add your control notification handler code here
	CColorDialog dlg(m_bkcolor, CC_FULLOPEN);
	if ( dlg.DoModal() == IDOK)
	{
		m_bkcolor = dlg.m_cc.rgbResult;
		m_Transparent = false;
	}
	UpdateData(false);
}

void CDlgUserPref::OnCmdfontcolor() 
{
	// TODO: Add your control notification handler code here
	CColorDialog dlg(m_textcolor, CC_FULLOPEN);
	if ( dlg.DoModal() == IDOK)
	{
		m_textcolor = dlg.m_cc.rgbResult;
	}
	UpdateData(false);
}

void CDlgUserPref::OnCmdimage() 
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(TRUE);

	char repertoire[255] = "";
	GetCurrentDirectory(255, repertoire);
	if (dlg.DoModal() == IDOK)
	{
		m_image = dlg.GetPathName();
	}
	SetCurrentDirectory(repertoire);
	UpdateData(false);
}

void CDlgUserPref::Init()
{
	m_bkcolor = userpref->TextBkColor;
	if (m_bkcolor == 0xFFFFFFFF)
	{
		m_Transparent = TRUE;
	}
	m_image   = userpref->ImageURi;
	m_textcolor = userpref->TextColor;
}

void URi (char *str)
{
	int i = 0;

	char *tmpImage;
	tmpImage = new char[strlen(str)+1];
	while (str[i])
	{
		if (str[i]=='\\' && str[++i] != '\\')
		{
			strcpy(tmpImage, &str[i]);
			str[i] = '\\';
			str[i+1] = '\0';
			strcat(str, tmpImage);
		}
		i++;
	}
}

void CDlgUserPref::OnOK() 
{
	// TODO: Add extra validation here
	
	UpdateData(true);
	if (m_Transparent) 
		userpref->TextBkColor = 0xFFFFFFFF;
	else
		userpref->TextBkColor = m_bkcolor;

	userpref->TextColor = m_textcolor;
	strcpy(userpref->ImageURi, m_image);
	URi(userpref->ImageURi);

	CDialog::OnOK();
}
