// Local.cpp: implementation of the CLocal class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "search.h"
#include "Local.h"
#include "xml.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLocal::CLocal()
{
	ordi = NULL;
	suivant = NULL;
}

CLocal::~CLocal()
{
	if (ordi)	
		delete ordi;
	ordi = NULL;
}

CLocal& CLocal::operator = (CLocal &local)
{
	NoLocal = local.NoLocal;
	ordi = local.ordi;
	suivant = local.suivant;
	return *this;
}

COrdi *CLocal::OrdiDansLocal(CString IP)
{
	COrdi *oSuivant=ordi;
	while (oSuivant)
	{
		if (IP == oSuivant->ip ) 
			return oSuivant;
		oSuivant = oSuivant->suivant;
	}
	return NULL;
}

void CLocal::Flush()
{
	COrdi *oSuivant=ordi;
	while (oSuivant)
	{
		oSuivant->user.Flush();
		oSuivant = oSuivant->suivant;
	}
}

char *CLocal::InitLocalXML(FILE *fxml, char *ligne)
{
	char *chaine = new char [strlen(ligne)+1];
	chaine = strCoupe(ligne, '<', '>');
	chaine = strCoupe(chaine, '\"', '\"');
	NoLocal = chaine;
    delete [] chaine;

	char *fLigne = new char [FILE_LMAX + 1];
	fLigne[0] = '\0';
	
	fgets(fLigne, FILE_LMAX, fxml);
	while (!feof(fxml) && !isXMLEnd(fLigne, "local"))
	{
		if (isXMLStart(fLigne, "ordi") && isXMLEnd(fLigne, "ordi"))
		{
			COrdi *newordi = new COrdi;
			newordi->InitOrdiXML(fxml, fLigne);
			InsereOrdi(newordi);
		}
		fgets(fLigne, FILE_LMAX, fxml);
	}

	return fLigne;
}


bool CLocal::InsereOrdi(COrdi *ordi)
{
	COrdi **oSuivant = &(this->ordi);
	while (*oSuivant)
			oSuivant = &(*oSuivant)->suivant;
	*oSuivant = ordi;
	return true;
}
