// UserPref.cpp: implementation of the UserPref class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "search.h"
#include "UserPref.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

UserPref::UserPref()
{
	bPlusBas = false;
	bPlusDroite = false;
	ImageURi[0]='\0';
	TextBkColor = CLR_NONE;
	TextColor   = 0;
	LireFichier();
}

UserPref::~UserPref()
{
	EcrireFichier();
}

void UserPref::LireFichier()
{
	int filter=0, r=0, g=0, b=0; // CLR_NONE;
	bPlusBas = false;

	FILE *f; 
	f = fopen(NOMFICHIER, "rt");

	if (f)
	{
		fscanf(f, "AffichePlus:%d\n", &bPlusBas);
		(bPlusBas)?bPlusBas=false:bPlusBas=true;

		fscanf(f, "AfficheDroite:%d\n", &bPlusDroite);
		(bPlusDroite)?bPlusDroite=false:bPlusDroite=true;

		fscanf(f, "TextBkColor:%d %d %d %d\n", &filter, &r, &g, &b);
		TextBkColor = RGB(r, g, b) + (filter<<24);
		fscanf(f, "TextColor:%d %d %d %d\n", &filter, &r, &g, &b);
		TextColor = RGB(r, g, b) + (filter<<24);
		fgets(ImageURi, 254, f);
		fclose(f);
	}
}

void UserPref::EcrireFichier()
{
	int filter=0, r=0, g=0, b=0; // CLR_NONE;

	FILE *f; 
	f = fopen(NOMFICHIER, "wt");

	if (f)
	{
		fprintf(f, "AffichePlus:%d\n", (UINT)bPlusBas);
		fprintf(f, "AfficheDroite:%d\n", (UINT)bPlusDroite);
		filter = TextBkColor >> 24;
		r      = TextBkColor & 0xFF; 
		g      = (TextBkColor >> 8) & 0xFF;
		b      = (TextBkColor >> 16) & 0xFF;
		fprintf(f, "TextBkColor:%d %d %d %d\n", filter, r, g, b);

		filter = TextColor >> 24;
		r      = TextColor & 0xFF; 
		g      = (TextColor >> 8) & 0xFF;
		b      = (TextColor >> 16) & 0xFF;
		fprintf(f, "TextColor:%d %d %d %d\n", filter, r, g, b);
		fputs(ImageURi, f);
		fclose(f);
	}
}
