// xml.cpp: implementation of the xml class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "xml.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

char *strCoupe (char *str, char debut, char fin)
{
  char *retour = new char [strlen(str)+1];
  retour[0] = '\0';
  int i=0, j=0;
  while (str[i] && str[i++]!=debut);
  if (str[i] && fin)
  {
	   while(str[i] && str[i] != fin)
		   retour[j++] = str[i++];
  }
  retour[j]='\0';
  return retour;
}

char *getTagValue(char *strLigne)
{
	return strCoupe(strLigne, '>', '<');
}

char *getAttValue(char *strXMLTag, char *attr)
{
  char *retour = new char [strlen(strXMLTag)+1];
  retour = strCoupe(strXMLTag, '<', '>');
  retour = strstr(retour, attr); 
  retour = strCoupe(retour, '\"', '\"');
  return retour;
}

bool isXMLStart(const char *strLigne, const char *strXMLTag)
{
	// doit avoir le format: [...]<nomTag{' '|'/'|'>'}[...]
	UINT i=0;
	int j;
	int lXML = strlen(strXMLTag);
	while (strLigne[i]!='<' && strLigne[i]) i++;
	if (i != strlen(strLigne)) 
	{
		j=0;
		i++;
		while (strLigne[i] && strXMLTag[j] &&
			   strLigne[i++] == strXMLTag[j]) j++;
		if (j==lXML && ( strLigne[i] == ' '  ||
			              strLigne[i] == '/' ||
						  strLigne[i] == '>' ))
			return true;
	}
	return false;
}

bool isXMLEnd(const char *strLigne, const char *strXMLTag)
{
	// doit avoir le format: [...]</nomTag{' '|'>'}[...]
	UINT i=0;
	int j;
	int lXML = strlen(strXMLTag);
	while (strLigne[i] &&
		   !(strLigne[i]=='<' && strLigne[i+1]=='/' )) 
		   i++;
	if (i != strlen(strLigne)) 
	{
		j=0;
		i+=2;
		while (strLigne[i] && strXMLTag[j] &&
			   strLigne[i++] == strXMLTag[j]) j++;
		if (j==lXML && ( strLigne[i] == ' '  ||
						  strLigne[i] == '>' ))
			return true;
	}
	return false;
}
